// SPDX-License-Identifier: UNLICENSED
pragma solidity ^0.8.9;

interface ICloudConstant {
    function onlyCaller(
        string memory key,
        address caller
    ) external view returns (bool);

    function onlyNode(address caller) external view returns (bool);

    function getCaller(string memory key) external view returns (address);

    // Common Key

    function USER() external view returns (uint8);

    function PASSWORD() external view returns (uint8);

    function CLUSTER() external view returns (uint8);

    function GLOBAL_ID() external view returns (uint8);

    function HOST() external view returns (uint8);

    function NAME() external view returns (uint8);

    function STAGE() external view returns (uint8);

    function PROGRESS() external view returns (uint8);

    // VM NET INFO KEY
    function EXTERNAL_IP() external view returns (uint8);

    function INTERNAL_IP() external view returns (uint8);

    function EX_SSH_PORT() external view returns (uint8);

    function EX_VNC_PORT() external view returns (uint8);

    function IN_VNC_PORT() external view returns (uint8);

    function IN_SSH_PORT() external view returns (uint8);

    // VM CONFIG INFO KEY
    function STATUS() external view returns (uint8);

    function MEM_NUM() external view returns (uint8);

    function CPU_LOGIC_UINTS() external view returns (uint8);

    function CPU_NUM() external view returns (uint8);

    function CPU_MODEL() external view returns (uint8);

    function CPU_CORES() external view returns (uint8);

    function GPU_MODEL() external view returns (uint8);

    function GPU_NUM() external view returns (uint8);

    function DISK() external view returns (uint8);

    function OS() external view returns (uint8);

    function BIND_WIDTH() external view returns (uint8);

    // Gateway Config Info Key
    function NPS_VNC_END_PORT() external view returns (uint8);

    function NPS_VNC_START_PORT() external view returns (uint8);

    function NPS_SSH_END_PORT() external view returns (uint8);

    function NPS_SSH_START_PORT() external view returns (uint8);

    function SINGALLING_HTTP_IP() external view returns (uint8);

    function SINGALLING_WS_IP() external view returns (uint8);

    function TURN_IP() external view returns (uint8);

    function TURN_PORT() external view returns (uint8);

    function TURN_USER() external view returns (uint8);

    function TURN_PWD() external view returns (uint8);

    function STUN_IP() external view returns (uint8);

    function STUN_PORT() external view returns (uint8);

    function SERVER_PORT() external view returns (uint8);

    function ENABLE() external pure returns (uint8);

    function DISABLE() external pure returns (uint8);

    function RE_BOOT() external pure returns (uint8);

    function DELETE() external pure returns (uint8);

    function VERSION() external view returns (uint8);

    function RESOLUTION_RATIO() external view returns (uint8);

    function IS_HDR_SUPPORTED() external view returns (uint8);

    function FPS() external view returns (uint8);

    function GAME_PADS() external view returns (uint8);
}
